[PATCH] cli: add a tool for starting new message in the emacs ui
David Bremner
david at tethera.net
Tue Jul 1 13:02:37 PDT 2014
From: Jani Nikula <jani at nikula.org>
Add a tool to start composing an email in the Notmuch Emacs UI with
the specified subject, recipients, and message body.
---
I added the necessary lines to conf.py to get the man pages built and installed
I'd be happier with this if it could start emacs. I tried adding "-a
''" to the emacsclient invokation, but that doesn't quite work; the
message-mode buffer is created in emacs but no frame is displayed. It
could be a peculiarity of my emacs setup, of course.
doc/conf.py | 4 ++
doc/man1/notmuch-emacs-mua.rst | 50 +++++++++++++++++
notmuch-emacs-mua | 122 +++++++++++++++++++++++++++++++++++++++++
3 files changed, 176 insertions(+)
create mode 100644 doc/man1/notmuch-emacs-mua.rst
create mode 100755 notmuch-emacs-mua
diff --git a/doc/conf.py b/doc/conf.py
index 70ba1b8..8ee19f4 100644
--- a/doc/conf.py
+++ b/doc/conf.py
@@ -74,6 +74,10 @@ man_pages = [
u'creates a plain-text dump of the tags of each message',
[u'Carl Worth and many others'], 1),
+('man1/notmuch-emacs-mua','notmuch-emacs-mua',
+ u'send mail with notmuch and emacs',
+ [u'Carl Worth and many others'], 1),
+
('man5/notmuch-hooks','notmuch-hooks',
u'hooks for notmuch',
[u'Carl Worth and many others'], 5),
diff --git a/doc/man1/notmuch-emacs-mua.rst b/doc/man1/notmuch-emacs-mua.rst
new file mode 100644
index 0000000..6e63818
--- /dev/null
+++ b/doc/man1/notmuch-emacs-mua.rst
@@ -0,0 +1,50 @@
+=================
+notmuch-emacs-mua
+=================
+
+SYNOPSIS
+========
+
+**notmuch-emacs-mua** [options ...] [<to-address> ...]
+
+DESCRIPTION
+===========
+
+Start composing an email in the Notmuch Emacs UI with the specified
+subject, recipients, and message body.
+
+For **notmuch-emacs-mua** to work, you need **emacsclient** and an
+already running Emacs with a server.
+
+Supported options for **notmuch-emacs-mua** include
+
+ ``-h, --help``
+ Display help.
+
+ ``-s, --subject=``\ <subject>
+ Specify the subject of the message.
+
+ ``--to=``\ <to-address>
+ Specify a recipient (To).
+
+ ``-c, --cc=``\ <cc-address>
+ Specify a carbon-copy (Cc) recipient.
+
+ ``-b, --bcc=``\ <bcc-address>
+ Specify a blind-carbon-copy (Bcc) recipient.
+
+ ``-i, --body=``\ <file>
+ Specify a file to include into the body of the message.
+
+ ``--print``
+ Output the resulting elisp to stdout instead of evaluating it.
+
+The supported positional parameters and short options are a compatible
+subset of the **mutt** MUA command-line options.
+
+Options may be specified multiple times.
+
+SEE ALSO
+========
+
+**notmuch(1)**, **emacsclient(1)**, **mutt(1)**
diff --git a/notmuch-emacs-mua b/notmuch-emacs-mua
new file mode 100755
index 0000000..7f94271
--- /dev/null
+++ b/notmuch-emacs-mua
@@ -0,0 +1,122 @@
+#!/usr/bin/env bash
+#
+# notmuch-emacs-mua - start composing a mail on the command line
+#
+# Copyright © 2014 Jani Nikula
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see http://www.gnu.org/licenses/ .
+#
+# Authors: Jani Nikula <jani at nikula.org>
+#
+
+set -eu
+
+escape ()
+{
+ echo "${1//\"/\\\"}"
+}
+
+PRINT_ONLY=
+
+# The crux of it all: construct an elisp progn and eval it.
+ELISP="(progn (require 'notmuch) (notmuch-mua-new-mail)"
+
+while getopts :s:c:b:i:h opt; do
+ # Handle errors and long options.
+ case "${opt}" in
+ :)
+ echo "$0: short option -${OPTARG} requires an argument." >&2
+ exit 1
+ ;;
+ \?)
+ opt=$1
+ if [ "${OPTARG}" != "-" ]; then
+ echo "$0: unknown short option -${OPTARG}." >&2
+ exit 1
+ fi
+
+ case "${opt}" in
+ # Long options with arguments.
+ --subject=*|--to=*|--cc=*|--bcc=*|--body=*)
+ OPTARG=${opt#--*=}
+ opt=${opt%%=*}
+ ;;
+ # Long options without arguments.
+ --help|--print)
+ ;;
+ *)
+ echo "$0: unknown long option ${opt}, or argument mismatch." >&2
+ exit 1
+ ;;
+ esac
+ # getopts does not do this for what it considers errors.
+ OPTIND=$((OPTIND + 1))
+ ;;
+ esac
+
+ OPTARG="$(escape "${OPTARG}")"
+
+ case "${opt}" in
+ --help|h)
+ exec man notmuch-emacs-mua
+ ;;
+ --subject|s)
+ ELISP="${ELISP} (message-goto-subject) (insert \"${OPTARG}\")"
+ ;;
+ --to)
+ ELISP="${ELISP} (message-goto-to) (insert \"${OPTARG}, \")"
+ ;;
+ --cc|c)
+ ELISP="${ELISP} (message-goto-cc) (insert \"${OPTARG}, \")"
+ ;;
+ --bcc|b)
+ ELISP="${ELISP} (message-goto-bcc) (insert \"${OPTARG}, \")"
+ ;;
+ --body|i)
+ ELISP="${ELISP} (message-goto-body) (cd \"${PWD}\") (insert-file \"${OPTARG}\")"
+ ;;
+ --print)
+ PRINT_ONLY=1
+ ;;
+ *)
+ # We should never end up here.
+ echo "$0: internal error (option ${opt})." >&2
+ exit 1
+ ;;
+ esac
+
+ shift $((OPTIND - 1))
+ OPTIND=1
+done
+
+# Positional parameters.
+for arg; do
+ arg="$(escape "${arg}")"
+ ELISP="${ELISP} (message-goto-to) (insert \"${arg}, \")"
+done
+
+# End progn.
+ELISP="${ELISP})"
+
+if [ -n "$PRINT_ONLY" ]; then
+ echo ${ELISP}
+ exit 0
+fi
+
+# Evaluate the progn.
+emacsclient --eval "${ELISP}" >/dev/null
+if [ $? -ne 0 ]; then
+ echo "$0: emacsclient failed" >&2
+ exit 1
+fi
--
2.0.0.rc2
More information about the notmuch
mailing list